/* Loadingbar.ts

		Purpose:
		
		Description:
		
		History:
				Fri Sep 27 14:17:19 CST 2019, Created by leon

Copyright (C) 2019 Potix Corporation. All Rights Reserved.

*/
(() => {
/**
 * A loadingbar widget.
 *
 * @since 9.0.0
 */
zkmax.wgt.Loadingbar = zk.$extends(zul.wgt.Progressmeter, {
	$init(opts: {id: string; pos: string; value: number; indeterminate: boolean; animationSpeed: number}) {
		this.$supers(zkmax.wgt.Loadingbar, '$init', arguments);
		this.uuid = opts.id;
		this._pos = opts.pos;
		this._value = opts.value;
		this._indeterminate = opts.indeterminate;
		this._animationSpeed = opts.animationSpeed;
	},
	redraw(out) {
		let colorbar = this.$s('colorbar');
		out.push('<div', this.domAttrs_(), '>');
		out.push('<span id="', this.uuid, '-img"', 'class="', this.$s('image'), ' ', colorbar, '"></span>');
		out.push('<span class="', this.$s('effectbar'), ' ', colorbar, '"></span>'); // for indeterminate animation
		out.push('</div>');
	},
	_fixImgWidth() {
		const n = this.$n(),
			img = this.$n('img');
		if (img) {
			if (zk(n).isRealVisible() && !this._indeterminateAnimation) {
				var $img = jq(img);
				$img.animate({
					width: this._value + '%'
				}, {
					duration: this._animationSpeed,
					queue: false,
					easing: 'linear',
					done: () => {
						if (this._value == 100)
							this.detach();
					}
				});
			}
		}
	}
}, {
	_positionWrappersCache: {},
	/**
	 * Start a Loadingbar.
	 */
	start(opts: {id: string; pos: string; value: number; indeterminate: boolean; animationSpeed: number}) {
		if (opts)
			jq(this.getPositionWrapper_(opts.pos)).append(new zkmax.wgt.Loadingbar(opts));
	},
	getPositionWrapper_(pos: string): HTMLElement {
		let cache: HTMLElement = this._positionWrappersCache[pos];
		if (!cache) {
			let wrapper = jq('#_z_loadingbarpositionwrapper');
			if (!wrapper.length) {
				wrapper = jq('<div id="_z_loadingbarpositionwrapper" class="z-loadingbar-position-wrapper"></div>')
					.appendTo(document.body);
			}
			cache = jq(`<div class="z-loadingbar-position z-loadingbar-position-${pos}"></div>`)
				.appendTo(wrapper)
				.get(0);
			this._positionWrappersCache[pos] = cache;
		}
		return cache;
	}
});
})();
