/* Step.js

		Purpose:

		Description:

		History:
				Thu Sep 12 11:35:49 CST 2019, Created by jameschu

Copyright (C) 2019 Potix Corporation. All Rights Reserved.

*/
(() => {
/**
* A stepbar.
* <p>Only support browsers that support Flex. (IE11, Edge, Chrome, Firefox, Safari)
*
* <p>Available in ZK EE.
* @author jameschu
* @since 9.0.0
*/
zkmax.wgt.Stepbar = zk.$extends(zul.Widget, {
	_wrappedLabels: false,
	_linear: true,
	_activeIndex: 0,
	$define: {
		/**
		 * Returns whether the labels in children steps is wrapped.
		 * <p>Default: false.
		 * @return boolean whether the labels in children steps is wrapped.
		 */
		/**
		 * Sets whether the labels in children steps is wrapped.
		 * @param boolean wrappedLabels the labels in children steps is wrapped.
		 */
		wrappedLabels(v: boolean) {
			if (this.desktop)
				jq(this.$n()).toggleClass(this.$s('wrapped-label'), v);
		},
		/**
		 * Returns whether the steps in this stepbar are displayed by order.
		 * <p>Default: true.
		 * @return boolean whether the steps in this stepbar are displayed by order.
		 */
		/**
		 * Sets whether the steps in this stepbar are displayed by order.
		 * @param boolean linear whether the steps in this stepbar are displayed by order.
		 */
		linear(v: boolean) {
			if (this.desktop)
				jq(this.$n()).toggleClass(this.$s('linear'), v);
		},
		/**
		 * Return the index of the active step.
		 * <p>Default: 0.
		 * @return int the index of the active step.
		 */
		/**
		 * Sets the index of the active step.
		 * @param int activeIndex the index of the active step.
		 */
		activeIndex(v: number, fromServer?: boolean) {
			if (this.desktop) {
				let childWgt = this.firstChild,
					i = 0;
				for (; childWgt; childWgt = childWgt.nextSibling, i++)
					childWgt._toggleActive(i == v);
				if (!fromServer) {
					this.fire('onChange', {activeIndex: v});
				}
			}
		}
	},
	_getActiveStep() {
		return this._getStepAt(this.getActiveIndex());
	},
	_getStepAt(index: number) {
		return this.getChildAt(index);
	},
	domClass_() {
		let cls = this.$supers('domClass_', arguments);
		if (this.isWrappedLabels())
			cls += ' ' + this.$s('wrapped-label');
		if (this.isLinear())
			cls += ' ' + this.$s('linear');
		return cls;
	}
});
})();